exec("./snowball.cs");
// item
datablock ItemData(SnowballMinigunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/snowball_minigun.dts";
	rotate = false;
	mass = 1;
	density = 1.2;
	elasticity = 0.2;
	friction = 0.9;
	emap = true;

	//gui stuff
	uiName = "Snowball Minigun";
	iconName = "./images/icon_snowballminigun";
	doColorShift = false;
	// colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = SnowballMinigunImage;
	canDrop = true;
};

//weapon image
datablock ShapeBaseImageData(SnowballMinigunImage)
{
   // Basic Item properties
   shapeFile = "./shapes/snowball_minigun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = minigunsnowballProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   // colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    	= "Activate";
	stateTimeoutValue[0]            	= 0.15;
	stateTransitionOnTimeout[0]     	= "Ready";
	stateSound[0]						= weaponSwitchSound;
	stateSequence[0]					= "Fire";

	stateName[1]                    	= "Ready";
	stateTransitionOnTriggerDown[1] 	= "Wait";
	stateAllowImageChange[1]        	= true;
	stateSequence[1]					= "Fire";
	
	stateName[2]						= "Wait";
	stateTimeoutValue[2]				= 1.0;
	stateTransitionOnTimeout[2]			= "Fire";
	stateTransitionOnTriggerUp[2]		= "Ready";
	stateSequence[2]					= "Fire";

	stateName[3]                    	= "Fire";
	stateTransitionOnTimeout[3]     	= "CheckFire";
	stateTimeoutValue[3]            	= 0.14;
	stateFire[3]                    	= true;
	stateAllowImageChange[3]        	= false;
	stateSequence[3]                	= "Fire";
	stateScript[3]                  	= "onFire";
	stateWaitForTimeout[3]				= true;
	stateSound[3]						= snowballminigunfireSound;
	stateEmitter[3]						= minigunsnowballSmokeEmitter;
	stateEmitterTime[3]					= 0.05;
	stateEmitterNode[3]					= "muzzleNode";

	stateName[4] 						= "CheckFire";
	stateTransitionOnTriggerDown[4] 	= "Fire";
	stateTransitionOnTriggerUp[4]		= "Exhaust";
	
	stateName[5]						= "Exhaust";
	stateTransitionOnTimeout[5]			= "Ready";
	stateTimeoutValue[5]				= 0.4;
	stateSequence[5]					= "Exhaust";
	stateSound[5]						= minigunsnowballairreleaseSound;
};

function SnowballMinigunImage::onFire(%this,%obj,%slot)
{     
   %projectile = %this.projectile;
   %spread = 0.00175;
   %vector = %obj.getMuzzleVector(%slot);
   %objectVelocity = %obj.getVelocity();
   %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
   %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
   %velocity = VectorAdd(%vector1,%vector2);
   %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
   %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
   %velocity = MatrixMulVector(%mat, %velocity);
   %p = new (%this.projectileType)()
   {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
   };
   MissionCleanup.add(%p);
}