datablock AudioProfile(minigunsnowballHitSound)
{
   filename = "Add-Ons/Weapon_Push_Broom/pushBroomHit.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(snowballminigunfireSound)
{
   filename    = "./sounds/snowballminigunfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(minigunsnowballairreleaseSound)
{
   filename    = "./sounds/airrelease.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(minigunsnowballSparkParticle)
{
   dragCoefficient      = 4;
   gravityCoefficient   = 1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 400;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
	
	useInvAlpha = false;
	spinSpeed		= 150.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;

   colors[0]     = "0.0 0.10 0.30 0.0";
   colors[1]     = "0.0 0.10 0.30 0.5";
   colors[2]     = "0.0 0.10 0.30 0.0";
   sizes[0]      = 0.15;
   sizes[1]      = 0.15;
   sizes[2]      = 0.15;

   times[0]	= 0.1;
   times[1] = 0.5;
   times[2] = 1.0;

   useInvAlpha = true;
};

datablock ParticleEmitterData(minigunsnowballSparkEmitter)
{
	lifeTimeMS = 10;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 3.0;
   ejectionOffset   = 1.50;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = minigunsnowballSparkParticle;

   uiName = "minigunsnowball Chunk";
};

datablock ParticleData(minigunsnowballExplosionParticle)
{
   dragCoefficient      = 6;
   gravityCoefficient   = -0.15;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 500;
   textureName          = "base/data/particles/chunk";

	spinSpeed		= 50.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "0.9 0.9 1.0 0.5";
   colors[1]     = "0.0 0.0 0.0 0.0";
   sizes[0]      = 0.2;
   sizes[1]      = 0.5;

   useInvAlpha = true;
};

datablock ParticleEmitterData(minigunsnowballExplosionEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 95;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = minigunsnowballExplosionParticle;

   uiName = "minigunsnowball Dust";
   emitterNode = HalfEmitterNode;
};

datablock ExplosionData(minigunsnowballExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 400;
   
   //emitter[0] = minigunsnowballExplosionEmitter;
   emitter[0] = minigunsnowballSparkEmitter;
   particleEmitter = minigunsnowballExplosionEmitter;
   particleDensity = 30;
	particleRadius = 0.5;
   
   faceViewer     = true;
   explosionScale = "0.5 0.5 0.5";

   soundProfile = minigunsnowballHitSound;

   
   shakeCamera = 0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.0 0.0 0.0";
   lightEndColor = "0 0 0";
};

datablock ParticleData(minigunsnowballTrailParticle)
{
   dragCoefficient = "2.99998";
   windCoefficient = "0";
   gravityCoefficient = "0.25";
   inheritedVelFactor = "0";
   constantAcceleration = "0";
   lifetimeMS = "250";
   lifetimeVarianceMS = "0";
   spinSpeed = "10";
   spinRandomMin = "-50";
   spinRandomMax = "50";
   useInvAlpha = "1";
   animateTexture = "0";
   framesPerSec = "1";
   textureName = "base/data/particles/chunk";
   animTexName[0] = "base/data/particles/chunk";
   colors[0] = "0.900000 0.900000 0.900000 0.08";
   colors[1] = "0.900000 0.900000 0.900000 0.000000";
   colors[2] = "0.600000 1.000000 1.000000 1.000000";
   colors[3] = "0.600000 1.000000 1.000000 1.000000";
   sizes[0] = "0.2";
   sizes[1] = "0.3";
   sizes[2] = "0.4";
   sizes[3] = "0.5";
   times[0] = "0";
   times[1] = "1";
   times[2] = "2";
   times[3] = "2";
};

datablock ParticleEmitterData(minigunsnowballTrailEmitter)
{
   className = "ParticleEmitterData";
   ejectionPeriodMS = "5";
   periodVarianceMS = "0";
   ejectionVelocity = "0";
   velocityVariance = "0";
   ejectionOffset = "0.3";
   thetaMin = "0";
   thetaMax = "25";
   phiReferenceVel = "0";
   phiVariance = "360";
   overrideAdvance = "0";
   orientParticles = "0";
   orientOnVelocity = "1";
   particles = "minigunsnowballTrailParticle";
   lifetimeMS = "0";
   lifetimeVarianceMS = "0";
   useEmitterSizes = "0";
   useEmitterColors = "1";
   uiName = "minigunsnowball Trail";
   doFalloff = "1";
   doDetail = "1";
};

AddDamageType("SnowballMinigun",   '<bitmap:add-ons/Weapon_SnowballMinigun/images/CI_snowballminigun> %1',    '%2 <bitmap:add-ons/Weapon_SnowballMinigun/images/CI_snowballminigun> %1',0.2,1);
datablock ProjectileData(minigunsnowballProjectile) 
{
   className = "ProjectileData";
   particleEmitter = "minigunsnowballTrailEmitter";
   projectileShapeName = "./shapes/minigun_snowball.dts";
   directDamage        = 15;
   directDamageType    = $DamageType::SnowballMinigun;
   radiusDamageType    = $DamageType::SnowballMinigun;
   scale = "1 1 1";
   sound = "";
   Explosion = "minigunsnowballExplosion";
   hasLight = "0";
   lightRadius = "5";
   lightColor = "6.000000 1.000000 1.000000 1.000000";
   hasWaterLight = "0";
   waterLightColor = "1.000000 1.000000 1.000000 1.000000";
   isBallistic = "1";
   collideWithPlayers = "1";
   velInheritFactor = "1";
   muzzleVelocity = "80";
   restVelocity = "1";
   lifetime = "8000";
   armingDelay = "0";
   fadeDelay = "8000";
   explodeOnDeath = "1";
   explodeOnPlayerImpact = "1";
   bounceAngle = "0";
   minStickVelocity = "0";
   uiName = "Minigun Snowball";
   bounceElasticity = "1.5";
   bounceFriction = "0.2";
   gravityMod = "1";
   doColorShift = 1;
   colorShiftColor = "1 0 1 1";
   impactImpulse	  = 600;
   verticalImpulse	  = 600;
};

datablock ParticleData(minigunsnowballSmokeParticle)
{
   dragCoefficient      = 6;
   gravityCoefficient   = -0.15;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 500;
   textureName          = "base/data/particles/chunk";

	spinSpeed		= 50.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "0.9 0.9 1.0 0.5";
   colors[1]     = "0.0 0.0 0.0 0.0";
   sizes[0]      = 0.1;
   sizes[1]      = 0.2;

   useInvAlpha = true;
};

datablock ParticleEmitterData(minigunsnowballSmokeEmitter)
{
	lifeTimeMS = 10;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 95;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = minigunsnowballSmokeParticle;

   uiName = "minigunsnowball Dust";
   emitterNode = HalfEmitterNode;
};